use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
pub struct VkCopyAccelerationStructureInfoKHR {
    pub sType: VkStructureType,
    pub pNext: *const c_void,
    pub src: VkAccelerationStructureKHR,
    pub dst: VkAccelerationStructureKHR,
    pub mode: VkCopyAccelerationStructureModeKHR,
}

impl VkCopyAccelerationStructureInfoKHR {
    pub fn new(
        src: VkAccelerationStructureKHR,
        dst: VkAccelerationStructureKHR,
        mode: VkCopyAccelerationStructureModeKHR,
    ) -> Self {
        VkCopyAccelerationStructureInfoKHR {
            sType: VK_STRUCTURE_TYPE_COPY_ACCELERATION_STRUCTURE_INFO_KHR,
            pNext: ptr::null(),
            src,
            dst,
            mode,
        }
    }
}
