use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
#[derive(Debug)]
pub struct VkPhysicalDeviceRayTracingPropertiesKHR {
    pub sType: VkStructureType,
    pub pNext: *mut c_void,
    pub shaderGroupHandleSize: u32,
    pub maxRayRecursionDepth: u32,
    pub maxShaderGroupStride: u32,
    pub shaderGroupBaseAlignment: u32,
    pub shaderGroupHandleCaptureReplaySize: u32,
    pub maxRayDispatchInvocationCount: u32,
    pub shaderGroupHandleAlignment: u32,
    pub maxRayHitAttributeSize: u32,
}

impl Default for VkPhysicalDeviceRayTracingPropertiesKHR {
    fn default() -> Self {
        VkPhysicalDeviceRayTracingPropertiesKHR {
            sType: VK_STRUCTURE_TYPE_PHYSICAL_DEVICE_RAY_TRACING_PIPELINE_PROPERTIES_KHR,
            pNext: ptr::null_mut(),
            shaderGroupHandleSize: 0,
            maxRayRecursionDepth: 0,
            maxShaderGroupStride: 0,
            shaderGroupBaseAlignment: 0,
            shaderGroupHandleCaptureReplaySize: 0,
            maxRayDispatchInvocationCount: 0,
            shaderGroupHandleAlignment: 0,
            maxRayHitAttributeSize: 0,
        }
    }
}

unsafe impl Sync for VkPhysicalDeviceRayTracingPropertiesKHR {}
unsafe impl Send for VkPhysicalDeviceRayTracingPropertiesKHR {}
